EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_background_type_set, EFL_FUNC_CALL(type), Efl_Text_Style_Background_Type type);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_background_type_get, Efl_Text_Style_Background_Type, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_background_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_background_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_underline_type_set, EFL_FUNC_CALL(type), Efl_Text_Style_Underline_Type type);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_underline_type_get, Efl_Text_Style_Underline_Type, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_underline_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_underline_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);

static Eina_Error
__eolian_efl_text_style_text_underline_height_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_text_underline_height_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_underline_height_set, EFL_FUNC_CALL(height), double height);

static Eina_Value
__eolian_efl_text_style_text_underline_height_get_reflect(const Eo *obj)
{
   double val = efl_text_underline_height_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_underline_height_get, double, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_underline_dashed_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_underline_dashed_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);

static Eina_Error
__eolian_efl_text_style_text_underline_dashed_width_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_text_underline_dashed_width_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_underline_dashed_width_set, EFL_FUNC_CALL(width), int width);

static Eina_Value
__eolian_efl_text_style_text_underline_dashed_width_get_reflect(const Eo *obj)
{
   int val = efl_text_underline_dashed_width_get(obj);
   return eina_value_int_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_underline_dashed_width_get, int, 0);

static Eina_Error
__eolian_efl_text_style_text_underline_dashed_gap_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_text_underline_dashed_gap_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_underline_dashed_gap_set, EFL_FUNC_CALL(gap), int gap);

static Eina_Value
__eolian_efl_text_style_text_underline_dashed_gap_get_reflect(const Eo *obj)
{
   int val = efl_text_underline_dashed_gap_get(obj);
   return eina_value_int_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_underline_dashed_gap_get, int, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_secondary_underline_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_secondary_underline_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_strikethrough_type_set, EFL_FUNC_CALL(type), Efl_Text_Style_Strikethrough_Type type);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_strikethrough_type_get, Efl_Text_Style_Strikethrough_Type, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_strikethrough_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_strikethrough_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_effect_type_set, EFL_FUNC_CALL(type), Efl_Text_Style_Effect_Type type);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_effect_type_get, Efl_Text_Style_Effect_Type, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_outline_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_outline_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_shadow_direction_set, EFL_FUNC_CALL(type), Efl_Text_Style_Shadow_Direction type);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_shadow_direction_get, Efl_Text_Style_Shadow_Direction, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_shadow_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_shadow_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_glow_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_glow_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_secondary_glow_color_set, EFL_FUNC_CALL(r, g, b, a), unsigned char r, unsigned char g, unsigned char b, unsigned char a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_secondary_glow_color_get, EFL_FUNC_CALL(r, g, b, a), unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);

static Eina_Error
__eolian_efl_text_style_text_gfx_filter_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   const char *cval;
   if (!eina_value_string_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_text_gfx_filter_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_gfx_filter_set, EFL_FUNC_CALL(code), const char *code);

static Eina_Value
__eolian_efl_text_style_text_gfx_filter_get_reflect(const Eo *obj)
{
   const char *val = efl_text_gfx_filter_get(obj);
   return eina_value_string_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_gfx_filter_get, const char *, NULL);

static Eina_Bool
_efl_text_style_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_TEXT_STYLE_EXTRA_OPS
#define EFL_TEXT_STYLE_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_text_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_background_type_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_background_type_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_background_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_background_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_type_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_type_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_height_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_height_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_width_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_width_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_gap_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_gap_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_secondary_underline_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_secondary_underline_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_strikethrough_type_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_strikethrough_type_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_strikethrough_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_strikethrough_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_effect_type_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_effect_type_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_outline_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_outline_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_shadow_direction_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_shadow_direction_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_shadow_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_shadow_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_glow_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_glow_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_secondary_glow_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_secondary_glow_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_gfx_filter_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_gfx_filter_get, NULL),
      EFL_TEXT_STYLE_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"text_underline_height", __eolian_efl_text_style_text_underline_height_set_reflect, __eolian_efl_text_style_text_underline_height_get_reflect},
      {"text_underline_dashed_width", __eolian_efl_text_style_text_underline_dashed_width_set_reflect, __eolian_efl_text_style_text_underline_dashed_width_get_reflect},
      {"text_underline_dashed_gap", __eolian_efl_text_style_text_underline_dashed_gap_set_reflect, __eolian_efl_text_style_text_underline_dashed_gap_get_reflect},
      {"text_gfx_filter", __eolian_efl_text_style_text_gfx_filter_set_reflect, __eolian_efl_text_style_text_gfx_filter_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_text_style_class_desc = {
   EO_VERSION,
   "Efl.Text_Style",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_text_style_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_text_style_interface_get, &_efl_text_style_class_desc, NULL, NULL);
